<?php
// PukiWiki - Yet another WikiWikiWeb clone.
// switchcontents system ver. 1 by jidaikobo.
// License: Same as PukiWiki.
/* usage
-put head of pukiwiki.skin.php below
include_once( PLUGIN_DIR . 'switchcontents.inc.php' ) ;
list( $title,$page,$body,$swc_ctrl ) = switchcontents( $title,$page,$body ) ;
$body = $swc_ctrl . $body ;
*/

define('SWC_LINK', '1') ; //SWC get 変換（1ににすると、極力 swc の get 値を引き継ごうとする）

function switchcontents( $title = NULL,$page = NULL,$body = NULL )
{
	global $vars ;

	//switch 取り出し
	$original = get_source( $vars['page'] ) ;
	$original = str_replace( array( "\r","\r\n" ),"\n", join( $original ) ) ;
	$original = str_replace( "\n", '-PKWKRETURN-', $original ) ;
	$regex = '/-PKWKRETURN-#switchcontents\((.*?)\)\{\{(.*?)\}\}(-PKWKRETURN-){0,1}/' ;

	//何も処理しない場合
	if( ! preg_match_all( $regex,$original,$matches ) || $vars['cmd'] != 'read' ){
		$retval[0] = $title ;
		$retval[1] = $page ;
		$retval[2] = $body ;
		$retval[3] = '' ;
		return $retval ;
	}

	//switch contents 処理
	foreach( $matches[1] as $k => $val ){
		//スイッチ項目
		$vals = explode( '|',$val ) ;
		foreach( $vals as $v ){
			list( $kk, $vv ) = explode( '=\'', $v) ;
			$vv = trim( trim( $vv ),"'" ) ;
			$kk = trim( $kk ) ;
			if( ! array_key_exists( $kk,array( 'switch','original','navigation','title','style' ) ) ){
				$args[$k][$kk] = htmlspecialchars( $vv,ENT_QUOTES ) ;
			}
		}
		//本文
		$txt = str_replace( '-PKWKRETURN-', "\n", $matches[2][$k] ) ;
		$args[$k]['body'] = trim( $txt ) ;
	}
	
	//不要コンテンツを破棄とコントローラ作成 - 泥臭い？？
	foreach( $args as $k => $val ){
		$ctrl[] = $val['switch'] ;
		if( $val['switch'] != $vars['switch'] ) unset( $args[$k] ) ;
	}
	sort( $args ) ; //配列をリセット
	//複数にわたっている場合の本文を結合
	$switched_body = '' ;
	foreach( $args as $v ){
		$switched_body.= $v['body']."\n" ;
	}
	$ctrl = array_unique( $ctrl ) ;

	//コントローラ作成
	$html[] = '<li><a href="'.get_script_uri().'?'.rawurlencode( $vars['page'] ).'">original</a></li>' ;
	foreach( $ctrl as $val ){
		$switches = htmlspecialchars( $val,ENT_QUOTES ) ;
		$html[] = '<li><a href="'.get_script_uri().'?cmd=read&amp;page='.rawurlencode( $vars['page'] ).'&amp;swc&amp;switch='.$switches.'">' . $switches . '</a></li>' ;
	}
	$ctrl = '<ul class="swc">'."\n".join( "\n",$html )."\n".'</ul>'."\n" ;

	//最終的な戻り値
	if( isset( $vars['swc'] ) ){
		global $swc ;
		$swc = isset( $vars['switch'] ) ? htmlspecialchars( $vars['switch'],ENT_QUOTES ) : NULL ;

		$title = htmlspecialchars( $args[0][title],ENT_QUOTES ) ;
		$retval[0] = $title ;
		$retval[1] = '<a href="'.get_script_uri().'?plugin=related&amp;page='.rawurlencode( $vars['page'] ).'">' . $title . '</a>' ;
		if( SWC_LINK ){
			$retval[2] = convert_html( $switched_body ) ;
			$retval[2] = preg_replace_callback( '/<a href="(.*?)"/','switchcontents_anchors',$retval[2] ) ;
		}else{
			$retval[2] = convert_html( $switched_body ) ;
		}
		$retval[3] = $ctrl ;
	}else{ // swc はあるが地の文を表示するとき
		$retval[0] = $title ;
		$retval[1] = $page ;
		$retval[2] = $body ;
		$retval[3] = $ctrl ;
	}

	return $retval ;
}

function switchcontents_anchors( $matches )
{
	global $swc ;

	if( strpos( $matches[1],get_script_uri() ) !== 0 ){
		return '<a href="'.$matches[1].'"' ;
	}else{
		$query = strpos( $matches[1], '?' );
		$str   = rawurldecode( substr( $matches[1],$query + 1 ) ) ;
		if( is_page( $str ) ){
			return '<a href="'.get_script_uri().'?cmd=read&amp;page='.rawurlencode( $str ).'&amp;swc&amp;switch=' . $swc .'"' ;
		}
	}
	return '<a href="'.$matches[1].'"' ;
}

function plugin_switchcontents_convert( $args )
{
	return ;
}

?>